"""HAMSplitter- the Korean capable Splitter"""

import string
import HAMLib

t_t=['',]*256
for i in range(256):
    if i < 48 or 57 < i < 65 or 90 < i < 97 or 122<i<127: t_t[i] = ' '
    #One can control which char will be treated as white space in the 
    #above line.
    else: t_t[i]= chr(i)
tt=string.join(t_t,'')


translate = string.translate
split = string.split
find = string.find


class HAMSplitter:
    """HAMSplitter- the Korean capable Splitter"""

    def __init__(self, doc, stopWordDic={}):
        keywordList = HAMLib.getKeywordList(doc)
        unparsed = string.join(keywordList, ' ')
        
        stopWords = stopWordDic.keys()
        
        result = []
        for keyword in keywordList:
            if keyword and len(keyword) > 1 and not keyword in stopWords:
                result.append(string.lower(keyword))
        
        self.keywords = result


    def __getslice__(self, a, b):
        return self.keywords[a:b]

    def __getitem__(self, a):
        return self.keywords[a]

    def __len__(self):
        return len(self.keywords)

    def indexes(self, a):
        res =[]
        for i in range(len(self)):
            if self[i]==a:
                res.append(i)
        return res

    def pos(self, a):
        i = int(a/2)
        x = find(self.unparsed, self[i])
        return (x, x+len(self[i]) )

